; include-file for v.com including routines for ascii-viewing
; coded 1996 by iCode
; all rights reserved

AscUp proc
      mov si, startpos
      cmp si, 2
      jae @go_on_04
      cmp filestartpos, 0
      jne @read_some_data
      ret
    @read_some_data:
      call step_backward
    @go_on_04:
      call AscSearchLastLine            ; Neue Position in SI
      cmp return_value, 0               ; Suche erfolgreich ?
      je @label113
      cmp return_value, 2
      je @label114
      ret                               ; nein, schon am Anfang des Files
    @label113:
    @label114:
      mov startpos, si
      call ascBuildFullscreen
      ret
ascUp endp

ascDown proc
    movzx eax, endpos
    add eax, filestartPos
    cmp eax, filesize
    jb $+3
    ret
    mov si, startpos
    call asc_search_next_line
    mov startpos, si
    call AscBuildFullScreen
    ret
ascDown endp


AscSearchLastLine proc                  ; sucht von SI-1 ausgehend, speichert in SI
        cmp si, 10
        jbe @nachladen_2
        dec si
        cmp byte ptr fs:[si], 1fh
        ja @Loop_12
        dec si
        cmp byte ptr fs:[si], 0dh
        jne @loop_12
        dec si
      @loop_12:
        cmp byte ptr fs:[si], 1fh           ; Zeilenumbruch erreicht ?
        ja Labelx
        cmp byte ptr fs:[si], 09h
        je Labelx
        jmp @Found_last_Line
      Labelx:
        cmp si, 0
        je @nachladen_2
        dec si
        jmp @loop_12
      @nachladen_2:
        cmp filestartpos, 0
        jne @read_d
        cmp startpos, 0
        je @raus25a
        xor si, si
        jmp @raus25b
      @read_d:
        call step_backward
        add si, bytes_moved
        jmp @loop_12
      @found_last_line:                     ; Anfang der letzten Zeile gefunden
        inc si
        mov return_value, 0
        ret
      @raus25a:                             ; Anfang des Files erreicht, Update
        mov return_value, 1
        ret
      @raus25b:                             ; Anfang des Files erreicht, kein Update
        mov return_value, 2
        ret
AscSearchLastLine endp



AscBuildFullScreen proc
        mov si, cs:startpos
        mov di, 160                     ; Bildschirm offset
        mov bx, 1840                    ; number
        cmp cs:keyMode, 0
        jne $+5
        call wait_retrace
        call AscBuildScreen
        ret
AscBuildFullScreen endp

; An diese Routine zu bergebende Register-Parameter:
;       SI = TextStartPosition
;       BX = Anzahl der zu schreibenden Zeichen
; Belegung der Register whrend der Ausfhrung dieser Routine :
;       ax = universeller Puffer, modifizierbar
;       cx = "
;       dl = "
;       dh = Zhler fr Anzahl Zeichen pro Zeile, maximal 80
;       DS:SI = @Text-Puffer
;       ES:DI = @Bildschirm
;       BX = Anzahl noch zu schreibender Zeichen (OHNE Attribute !)

AscBuildScreen proc
        cld
        push 0b800h
        pop es                          ; ES:DI @Screen
        push cs
        pop ds
        mov fs, text_seg
        push bx
        xor dh, dh
        call DrawLeftArrow
      @draw_loop:
        cmp si, bufferSize            ; Ende des Text-Puffers ?
        jb $+5
        jmp EndOfVisibleScreen
        cmp dh, 79                      ; Zeilenende erreicht ?
        jb NichtRechts
        xor dh, dh
        cmp byte ptr fs:[si], 0dh       ; folgt ein Wagenrcklauf...
        je NichtRechts
        cmp byte ptr fs:[si], 0ah       ; ... nder ein Papiervorschub ?
        je NichtRechts
        mov al, 0afh                    ; ASCII : Pfeil nach rechts
        mov ah, colour1                 ; Farbcode laden
        and ah, 0f0h                    ; Vordergrund ausblenden...
        add ah, 0eh                     ; ...und auf gelb setzen
        stosw                           ; gelben Rechts-Pfeil ausgeben
        call asc_search_next_line       ; Anfang der nchsten Zeile suchen...
        mov endpos, si                  ; ...und sichern
        jmp @check
      NichtRechts:
        mov al, fs:[si]                 ; Zeichen in AL laden
        cmp al, 09h                     ; Ist Zeichen ein #9 (tab) ?
        jne NoTabulator
        mov ax, horizStart
        shl ax, 1
        add ax, di
        mov dl, 16
        div dl
        mov cl, 16
        sub cl, ah
        xor ch, ch
        shr cx, 1
        push cx
        mov ah, colour1
        mov al, 20h
        rep stosw                       ; Leerzeichen ausgeben, max. 8 Stck
        mov ax, di
        shr ax, 1
        pop cx
        sub bx, cx
        shr ax, 1
        inc si                          ; nchstes Zeichen...
        jmp @draw_loop
      NoTabulator:
        cmp al, 1fh                     ; Steuerzeichen ?
        ja DrawSign
      CarriageReturn:
        mov ax, di                      ; }
        shr ax, 1                       ; }
        mov dl, 80                      ; }
        div dl                          ; } 
        mov al, 80                      ; } AX:= 80-( DI div 2 mod 80 )
        sub al, ah                      ; }
        xor ah, ah                      ; }
        mov bp, ax                      ; sichern...
        mov cx, ax
        mov ah, colour1
        mov al, 20h
        rep stosw                       ; Zeile fllen (SPACE)
        cmp bx, bp                      ; Bildschirmende erreicht ?
        jbe EndOfVisibleScreen
        sub bx, bp                      ; Zu schreibende Zeichenanzahl erniedrigen
        inc si                          ; DS:SI @nchstes Zeichen
        cmp byte ptr fs:[si], 0ah
        jne lb02
        inc si
      lb02:
        xor dh, dh
        call DrawLeftArrow              ; eventuell Pfeilspitze (nach links) ausgeben
        jmp @draw_loop
  ; 5. Schritt : Zeichen in Bildschirmspeicher schreiben
      DrawSign:
        mov ah, colour1
        stosw
        inc si
        inc dh
  ; 6. Schritt : berschreiten des Bildschirms verhindern
      @check:
        dec bx
        cmp bx, 0
        je EndOfVisibleScreen
        cmp di, 24*160-2
        jne @qwqww
        mov al, fs:[si]
        cmp al, 0dh
        je @qwqww
        cmp al, 0ah
        je @qwqww
        mov al, 0afh
        mov ah, colour1
        and ah, 0f0h
        add ah, 0eh
        stosw
        jmp EndOfVisibleScreen
      @qwqww:
        cmp si, bufferSize
        jae @nachladen
        cmp si, 0
        je @nachladen
        jmp @draw_loop
  ; 6. Schritt : Das Ende des Puffers ist erreicht. Testen, ob nachgeladen
  ; werden kann...
      @nachladen:
        mov ax, bufferSize
        cmp ax, 0ffffh
        jne @fill_screen
        call step_forward
        mov ax, bytes_moved
        sub si, ax
        sub startpos, ax
        jmp @draw_loop
  ; 7. Schritt : Der Bildschirm ist fertig aufgebaut, alle Zeichen sind ausgegeben
      EndOfVisibleScreen:
        pop bx
        mov endpos, si
        cmp di, 4000-160
        jae @raushier
        cmp bx, 80
        je @raushier
        jmp @fill_screen
        @raushier:
        ret
  ; 8. Schritt : Gegebenfalls den restlichen Teil des Screens berschreiben
      @fill_screen:
        mov ah, colour1
        mov al, 20h
        mov cx, 4000-160
        sub cx, di
        shr cx, 1
        rep stosw
        jmp EndOfVisibleScreen
AscBuildScreen endp

DrawLeftArrow proc                      ; Handling fr die Rechts-Verschiebung
        mov ax, horizStart             ; Nach Rechts Verschiebung vorhanden ?
        or ax, ax
        jnz $+3
        ret
        cmp di, 24*160                  ; Innerhalb des Bildschirms ?
        jb $+3
        ret
        mov al, 0aeh                    ; ASCII-Code fr Links-Pfeil
        mov ah, colour1                 ; Farbcode laden
        and ah, 0f0h                    ; Vordergrund ausschalten...
        add ah, 0eh                     ; ...und auf gelb setzen
        stosw                           ; Zeichen ausgeben
        dec bx                          ; Ein Zeichen weniger zu schreiben
        mov cx, horizStart             ; Maximale Verschiebung ist LinkerRand
        inc cx
        inc dh
      loop1234:
        cmp byte ptr fs:[si], 1fh
        ja Label3
        cmp byte ptr fs:[si], 9
        je Label3
        jmp Label2
      Label3:
        inc si
        loop loop1234
      Label2:
        inc si
        ret
DrawLeftArrow endp

shift_screen_right proc
  cmp cs:horizStart, 9999
  je @leave_proc_1
  inc cs:horizStart
  call AscBuildFullScreen
@leave_proc_1:
  ret
endp

shift_screen_left proc
  mov ax, cs:horizStart
  cmp ax, 0
  je @raus334
  dec ax
  mov cs:horizStart, ax
  call AscBuildFullScreen
@raus334:
  ret
endp

jump_to_begin proc
  pusha
  ; 1. Schritt: berprfen, ob nachgeladen werden mu
  mov bx, word ptr cs:filestartpos
  mov ax, word ptr cs:filestartpos+2
  cmp ax, 0
  jne @lesen
  cmp bx, 0
  jne @lesen
  jmp @weiter555
@lesen:
  mov filestartpos, 0
  mov ax, 4200h
  xor cx, cx
  xor dx, dx
  mov bx, fileHandle
  int 21h
  call readData
@weiter555:
  mov startpos, 0
  cmp mode, 1
  je @leave_proc_2
  mov horizStart, 0
@leave_proc_2:
  popa
  ret
endp

AscEnd proc
        mov eax, filestartpos
        movzx ebx,endpos
        add eax, ebx
        mov ebx, filesize
        cmp eax, ebx
        jne @weiter13
        mov ax, horizStart
        cmp ax, 0
        jne @weiter13
        ret
      @weiter13:
        mov horizStart, 0
        cmp ebx, 2100
        jae @weiter70
        mov bp, bx
        jmp @weiter71
      @weiter70:
        mov bp, 0834h
      @weiter71:
        movzx eax, bp
        sub ebx, eax
        mov eax, filestartpos
        movzx ecx, bufferSize
        add eax, ecx
        cmp ebx, eax
        jb @weiter14
      @readdata:                          ; Es muss nachgeladen werden !
        mov filestartpos, ebx
        mov dx, bx
        shr ebx, 16
        mov cx, bx
        mov ax, 4200h
        mov bx, fileHandle
        int 21h                           ; Positionszeiger vorruecken
        jnc @weiter17a
        jmp @error
      @weiter17a:
        call readdata                     ; Daten lesen
        mov ax, bp
        mov bufferSize, ax
      @weiter14:                          ; jetzt die letzte Seite suchen...
        mov si, bufferSize
        mov startpos, si
        mov cl, 23
      @loop20a:
        push cx
        mov si, startpos
        call AscSearchLastLine
        mov startpos, si
        pop cx
        dec cl
        cmp cl, 0
      jne @loop20a
        call AscBuildFullScreen
        ret
AscEnd endp

AscPageUp proc
        cmp filestartpos, 0
        jne goPageUp
        cmp startpos, 0
        jne goPageUp
        ret
      goPageUp:
        mov cl, 23
      @loop20:
        push cx
        mov si, startpos
        call AscSearchLastLine
        mov startpos, si
        pop cx
        dec cl
        cmp cl, 0
      jne @loop20
        call AscBuildFullScreen
        ret
AscPageUp endp

asc_search_next_line proc
    xor dh, dh
  @loop222:
    cmp byte ptr fs:[si], 1fh
    ja nextByte
    cmp byte ptr fs:[si], 09h
    je nextByte
    jmp foundLine
  nextByte:
    inc si
    jmp @loop222
  foundLine:
    inc si
    cmp byte ptr fs:[si], 0ah
    jne @raus779
    inc si
  @raus779:
    call DrawLeftArrow
    ret
endp




asc_scroll_page_down proc
    mov eax, filestartpos
    movzx ebx, cs:endpos
    add eax, ebx
    cmp eax, filesize
    jb @check_for_load
    ret
  @check_for_load:
    mov ax, bufferSize
    cmp ax, endpos
    jne @weiter11
    call step_forward
    sub si, bytes_moved
  @weiter11:
    mov si, cs:endpos
    mov al, fs:[si]
    cmp al, 0dh
    je @label_a
  @label_b:
    mov al, fs:[si]
    inc si
    cmp al, 0dh
    je @label_c
    jmp @label_b
  @label_c:
    dec si
    mov endpos, si
  @label_a:
    mov ax, endpos
    add ax, 2
    mov startpos, ax
    call AscBuildFullScreen
    ret
endp
