; include file including hex-routines for v.com
; coded 1996 by iCode
; all rights reserved

clear_rest proc
        mov bx, 3840
        sub bx, di
        mov cx, bx
        shr cx, 1
        cld
        mov ah, colour1
        mov al, 20h
        rep stosw
        ret
Clear_Rest endp

HexBuildScreen proc
        mov ax, cs
        mov ds, ax
        mov ax, 0b800h
        mov es, ax
        mov fs, text_seg
      HexLineLoop:
        dec bl
        mov cl, 10h
        push si

        push bx                         ; }
        movzx eax, si                   ; }
        add eax, filestartpos           ; }
        rol eax, 8                      ; }
        push eax                        ; }
        call hex_draw_value             ; }
        pop eax                         ; }
        rol eax, 8                      ; }
        push eax                        ; }
        call hex_draw_value             ; }
        pop eax                         ; } Dateioffset am linken Rand ausgeben
        rol eax, 8                      ; }
        push eax                        ; }
        call hex_draw_value             ; }
        pop eax                         ; }
        rol eax, 8                      ; }
        call hex_draw_value             ; }
        call draw_space                 ; }
        call draw_space                 ; }
        pop bx                          ; }

        mov ch, 4
      HexValueLoop:
        mov al, fs:[si]                 ; }
        inc si                          ; } Wert laden und hexadezimal ausgeben
        call hex_draw_value             ; }

        call draw_space                     ; Leerzeichen ausgeben
        dec ch
        dec cl                              ; Zeichenzaehler erniedrigen, 0-16
        jz AsciiSigns
        cmp bufferSize, si                ; } wenn Puffer keine Daten mehr
        jne @weiter22                       ; } enthlt, dan nicht verzweigen
        pusha
        call hex_step_forward               ; in der datei vorwaerts 'springen'
        popa
        cmp bytes_moved, 0
        je FileEnd

        pop si
        sub si, bufferSize
        add si, 20d
        push si                             ; Zeichen am rechten Rand auszugeben,
        mov si, 20d                         ; entsprechend modifizieren u. sichern
        jmp HexValueLoop
      FileEnd:
        mov ax, di                          ; nein, die Datei ist nicht laenger...
        mov cl, 160                         ; jetzt den Rest der Bildschirmhaelfte,
        div cl                              ; auf der die HEX-Werte stehen, loe-
        mov ch, 128                         ; schen...
        sub ch, ah
        shr cx, 9
        mov ah, colour1
        mov al, 20h
        rep stosw
        jmp AsciiSigns

      @weiter22:
        cmp ch, 0
        jne @weiter5
        mov al, 0bah
        stosb
        inc di
        call draw_space
        mov ch, 4
      @weiter5:
        jmp HexValueLoop
      AsciiSigns:
        mov cl, 16
  ; 2. Schritt: 16 ASCII-Zeichen ausgeben
  ; *************************************
        pop si
      @hex_sign_loop:
        mov ah, colour1                     ; Attribut laden
      @hex_sign_loop2:
        mov al, fs:[si]
        inc si
        stosw                               ; und das Word ausgeben
        dec cl                              ; Zeichenzaehler erniedrigen
        cmp si, bufferSize                ; am Ende der Datei angelangt ?
        je @fertig3                         ; ja, wird sind fertig mit dem Aufbau
        cmp cl, 0                           ; vielleicht am Ende der Zeile angelangt ?
        jne @hex_sign_loop2                 ; nein, weitermachen
        cmp bl, 0                           ; ja, aber war's die letzte Zeile ?
        je @hex_last_line_reached           ; ja, raus hier
        jmp HexLineLoop                 ; nein, naechste Zeile...
      @fertig3:
        call hex_step_forward
        cmp bytes_moved, 0
        je @4321
        mov si, 20d                         ; entsprechend modifizieren u. sichern
        jmp HexLineLoop
      @4321:
        call clear_rest                     ; den Rest des Bildschirms ueberschreiben
      @hex_last_line_reached:
        mov endpos, si
        ret                                 ; Zurueck in die Hauptschleife...
HexBuildScreen endp

HexEnd proc
        mov ax, cs
        mov ds, ax
        mov fs, text_seg
        movzx eax, endpos
        add eax, filestartpos
        cmp eax, filesize
        jb @weiter13b
        ret
      @weiter13b:
        movzx eax, bufferSize
        add eax, filestartpos
        add eax, 400
        cmp eax, filesize
        ja @weiter666
      @weiter13c:
        mov eax, filesize
        cmp eax, 010000h
        jb @label52
        sub eax, 0ffffh
        jmp @label51
      @label52:
        xor eax, eax
      @label51:
        mov filestartpos, eax
        mov dx, ax
        shr eax, 16
        mov cx, ax
        mov ax, 4200h
        mov bx, cs:fileHandle
        int 21h                           ; Positionszeiger vorruecken
        jnc @weiter17c
        jmp @error
   ; 5. Schritt: Daten einlesen
      @weiter17c:
        call readdata
   ; 6. Schritt: Startposition setzen
      @weiter666:
        mov ax, cs:bufferSize
        sub ax, 23*16
        mov cs:startpos, ax
        call hexBuildFullScreen
        ret
HexEnd endp

hexBuildFullScreen proc
    mov si, cs:startpos
    mov di, 160                           ; Bildschirm offset
    mov bl, 23                            ; Anzahl der Zeilen
    cmp cs:keyMode, 1
    je @go_2
    call wait_retrace
  @go_2:
    call HexBuildScreen
    ret
hexBuildFullScreen endp



hex_step_forward proc
        pusha
        mov ax, cs
        mov ds, ax

        xor si, si                      ; }
        movzx eax, bufferSize         ; }
        add eax, filestartpos           ; } FileStartpos:=
        cmp eax, filesize
        jae NoBytesAnymore
        sub eax, 20                     ; } FileStartpos + bufferSize - 20h
        mov filestartpos, eax           ; }
        mov startpos, 0

        mov dx, ax                      ; }
        shr eax, 16                     ; }
        mov cx, ax                      ; }
        mov ax, 4200h                   ; } seek(fileHandle, filestartpos);
        mov bx, fileHandle                  ; }
        int 21h                         ; }
        jnc NoReadError
        popa
        add sp, 2
        jmp @error
      NoReadError:
        popa
        call readdata
        sub cs:bytes_moved, 20d
        ret
     NoBytesAnymore:
        popa
        mov cs:bytes_moved, 0
        ret
hex_step_forward endp

hex_draw_nibble proc                    ; al : bits 0,1,2,3 = Wert
  push ax
  mov ah, cs:colour1
  cmp al, 9
  ja @hex_wert
    add al, 30h
    jmp @fertig
  @hex_wert:
    add al, 37h
  @fertig:
    stosw
  pop ax
  ret
endp

hex_draw_value proc                     ; al=Wert
  push ax
  shr al, 4
  call hex_draw_nibble
  pop ax
  and al, 00001111b
  call hex_draw_nibble
  ret
endp

Hex_scroll_page_up proc
  mov ax, cs:startpos
  cmp ax, 23*16
  jae @label30
      mov bx, cs:[word ptr cs:filestartpos]
      mov ax, cs:[word ptr cs:filestartpos+2]
      cmp ax, 0
      jne @read_da
      cmp bx, 0
      jne @read_da
      jmp @raus33
    @read_da:
    call step_backward
  @label30:
  mov ax, cs:startpos
  sub ax, 23*16
  mov cs:startpos, ax
  call hexBuildFullScreen
  ret
  @raus33:
    xor ax, ax
    mov cs:startpos, ax
    call hexBuildFullScreen
    ret
endp

HexUp proc
        push cs
        pop ds
        mov ax, startpos
        cmp ax, 10h
        jae @label30a
        mov eax, FileStartPos
        cmp eax, 0
        jne @read_da
        jmp @raus33a
      @read_daa:
        call step_backward
      @label30a:
        sub startpos, 16
        cmp keyMode, 1
        je @no_wait_retrace_1
        call wait_retrace
      @no_wait_retrace_1:
        mov ax, 0701h
        mov cx, 0100h
        mov dx, 174fh
        mov bh, colour1
        int 10h                                 ; Seite hoch scrollen
        mov di, 160
        mov bl, 1
        push endpos
        mov si, startpos
        call HexBuildScreen
        pop endpos
        sub endpos, 16
        ret
      @raus33a:
        xor ax, ax
        mov startpos, ax
        call hexBuildFullScreen
        ret
HexUp endp

hex_scroll_page_down proc
        mov ax, cs
        mov ds, ax
        mov ax, bufferSize
        cmp ax, endpos
        jne @hex_weiter11
        ret
      @hex_weiter11:
        mov ax, endpos
        mov startpos, ax
        call hexBuildFullScreen
        ret
endp



HexDown proc
        push cs
        pop ds
        mov eax, filestartpos
        movzx ebx, endpos
        add eax, ebx
        mov ebx, filesize
        cmp eax, ebx
        jb @label50
        ret
      @label50:
        mov ax, startpos
        add ax, 10h
        push ax
        mov ax, endpos
        mov startpos, ax
        cmp keyMode, 1
        je @no_wait_retrace
        call wait_retrace
      @no_wait_retrace:
        mov ax, 0601h
        mov cx, 0100h
        mov dx, 174fh
        mov bh, colour1
        int 10h                                 ; Seite hoch scrollen
        mov di, 23*160
        mov bl, 1
        mov si, endpos
        call HexBuildScreen
        pop startpos
        ret
hexDown endp


